function Create(self)
    self.guncurdist = 100; --The distance of the bullet from the gun.
    for i = 1,MovableMan:GetMOIDCount()-1 do
        self.gun = MovableMan:GetMOFromID(i);
        if self.gun.PresetName == "Masher" and self.gun.ClassName == "HDFirearm" and (self.gun.Pos-self.Pos).Magnitude < self.guncurdist then
            self.actor = MovableMan:GetMOFromID(self.gun.RootID);
            if MovableMan:IsActor(self.actor) then
                self.parent = ToActor(self.actor);
            end
         end
    end
end

function TeleportEffect(Xpos, Ypos)
	local particle = CreateMOPixel("Masher Teleport Flash", "Masher.rte");
	particle.Pos = Vector(Xpos, Ypos);
	MovableMan:AddParticle(particle);
	for i=0, 50, 1 do
		particle = CreateMOPixel("Masher Spark", "Masher.rte");
		particle.Pos = Vector(Xpos, Ypos);
		particle.Vel = Vector(RangeRand(-10, 10), RangeRand(-10, 10));
		MovableMan:AddParticle(particle);
	end
end

function Update(self)
    if not(MovableMan:IsActor(self.parent)) then
        self.ToDelete = true;
    end

	for i=0, 3, 1 do
		particle = CreateMOPixel("Masher Spark", "Masher.rte");
		particle.Pos = self.Pos;
		particle.Vel = (self.Vel / 4)  + Vector(RangeRand(-2, 2), RangeRand(-2, 2));
		MovableMan:AddParticle(particle);
	end


    local teledist = 40;
    for actor in MovableMan.Actors do
        local avgx = actor.Pos.X - self.Pos.X;
        local avgy = actor.Pos.Y - self.Pos.Y;
        local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
        if dist < teledist and actor.ID ~= self.parent.ID and actor.PinStrength == 0 then
			TeleportEffect(actor.Pos.X, actor.Pos.Y);
			
			local offset = 0;
            if actor.Pos.X >= self.parent.Pos.X then
                offset = 50;
            elseif  actor.Pos.X <= self.parent.Pos.X then
                offset = -50;
            end
            
            actor.Pos = Vector(self.parent.Pos.X + offset, self.parent.Pos.Y);
            TeleportEffect(self.parent.Pos.X + offset, self.parent.Pos.Y);
            
            
            self.ToDelete = true;
            return;
        end
    end
end